;Include Modern UI
  !include "MUI.nsh"
;--------------------------------
;--------------------------------
;Interface Settings
  !define MUI_ABORTWARNING
;--------------------------------
;Pages

  !define MUI_HEADERIMAGE
 ; !insertmacro MUI_PAGE_LICENSE "License.txt"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
;--------------------------------
;Languages
  !insertmacro MUI_LANGUAGE "English"
;--------------------------------

; The name of the installer
Name "Pack - Archive creator"

; The file to write
OutFile "Pack_Setup.exe"

; The default installation directory
InstallDir "$PROGRAMFILES\Pack"

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\Pack" "Install_Dir"



;--------------------------------
XPStyle on



; The stuff to install
Section "Pack" scv

  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File pack.exe
  File ulzw_dll.dll
  File icon.ico
  
  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\Pack" "Install_Dir" "$INSTDIR"
  
  WriteRegStr HKCR ".pack" "" "pack.pack"
  WriteRegStr HKCR "pack.pack" "" "pack archive"
  WriteRegStr HKCR "pack.pack\shell" "" ""
  WriteRegStr HKCR "pack.pack\DefaultIcon" "" "$INSTDIR\icon.ico"
  WriteRegStr HKCR "pack.pack\shell\open" "" ""
  WriteRegStr HKCR "pack.pack\shell\open\command" "" '"$INSTDIR\pack.exe" "-x" "%1" "%1"'
  WriteRegStr HKCR "Folder\shell\Add to pack archive" ""  ""
  WriteRegStr HKCR "Folder\shell\Add to pack archive\command" "" '$INSTDIR\pack.exe  -c "%1" "%1.pack"'
  
  
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Pack" "DisplayName" "Pack"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Pack" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Pack" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Pack" "NoRepair" 1
  WriteUninstaller "uninstall.exe"

  Pop $0 ; return error(1)/success(0)

SectionEnd


; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts" sms
  CreateDirectory "$SMPROGRAMS\Pack"
  CreateShortCut  "$SMPROGRAMS\Pack\Pack.lnk" "$INSTDIR\pack.exe" "" "$INSTDIR\pack.exe" 0
  CreateShortCut  "$SMPROGRAMS\Pack\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
SectionEnd




;Descriptions

  ;Language strings
  LangString DESC_scv ${LANG_ENGLISH} "Software binary files and manual"
  LangString DESC_sms ${LANG_ENGLISH} "Start Menu Shortcuts links"
  ;Assign language strings to sections
  

  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${scv} $(DESC_scv)
  !insertmacro MUI_DESCRIPTION_TEXT ${sms} $(DESC_sms)

  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKCR ".pack"
  DeleteRegKey HKCR "pack.pack"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Pack"
  DeleteRegKey HKLM "SOFTWARE\Pack"
  DeleteRegKey HKCR "Folder\shell\Add to pack archive"

  Pop $0 ; return error(1)/success(0)
    
  ; Remove files and uninstaller
  Delete $INSTDIR\*.*

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\Pack\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\Pack"
  RMDir "$INSTDIR"
SectionEnd